' 

    #INCLUDE "reference.inc"

' 

FUNCTION PBmain() AS LONG

    LOCAL  Wid            as LONG                   ' local variable for window width
    LOCAL  Hgt            as LONG                   ' LOCAL variable for window height
    LOCAL  wcex           as WNDCLASSEX             ' the WNDCLASSEX structure
    LOCAL  szClassName    as ASCIIZ * 32            ' stack buffer for zero terminated class name string
    LOCAL  szDisplayName  as ASCIIZ * 128           ' stack buffer for zero terminated window title

    hInstance = GetModuleHandle(ByVal %NULL)        ' get the instance handle
    Sw = GetSystemMetrics(%SM_CXSCREEN)             ' get the screen X and Y size
    Sh = GetSystemMetrics(%SM_CYSCREEN)

    szDisplayName = "Reference Window"              ' set the window title text
    szClassName   = "Reference_Win_Class"           ' set the class name for the window

    hIcon   = LoadIcon(hInstance,ByVal 1)           ' get system icon and cursor handles
    hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)

    MessageBox 0,"Writing required information to the WNDCLASSEX structure next", _
                 "Setting up the windows class",%MB_OK

  ' ---------------------------------------------------------------------
  ' preload the WNDCLASSEX structure with arguments for RegisterClassEx()
  ' ---------------------------------------------------------------------

    wcex.cbSize        = SIZEOF(wcex)               ' set the structure size in bytes
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)           ' set the address of the message handling function
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance                  ' set the instance handle
    wcex.hIcon         = hIcon                      ' set the icon handle
    wcex.hCursor       = hCursor                    ' set the cursor handle
    wcex.hbrBackground = %COLOR_BTNFACE + 1         ' set the window background colour
    wcex.lpszMenuName  = %NULL                      ' no menu is set here
    wcex.lpszClassName = VarPtr(szClassName)        ' set the address of the window class name
    wcex.hIconSm       = %NULL

    MessageBox 0,"Registering the window class","Reference Window",%MB_OK

    RegisterClassEx wcex                            ' register the window class

    Wid = Sw * .75   ' Set width & height to percentage of screen size.
    Hgt = Sh * .70

    MessageBox 0,"Calling the CreateWindowEx() function next","Reference Window",%MB_OK

    hWnd = CreateWindowEx( _
                        %WS_EX_LEFT, _              ' extended style
                        szClassName, _              ' window class name
                        szDisplayName, _            ' window title
                        %WS_OVERLAPPEDWINDOW, _     ' window style
                        Sw\2-(Wid\2), _             ' initial x position
                        Sh\2-(Hgt\2), _             ' initial y position
                        Wid, _                      ' initial x size
                        Hgt, _                      ' initial y size
                        %NULL, _                    ' parent window handle
                        %NULL, _                    ' window menu handle
                        hInstance, _                ' program instance handle
                        ByVal %NULL)                ' creation parameters

    MessageBox hWnd,"Show and enable the window as the next operation", _
                    "Calling Showindow() and UpdateWindow()",%MB_OK

    ShowWindow hWnd, %SW_SHOW                       ' show the window
    UpdateWindow hWnd                               ' enable the window

    FUNCTION = MessageLoop                          ' call the remote message loop function

END FUNCTION

' 

FUNCTION MessageLoop as DWORD

  ' ----------------------------------------------------------------
  ' the two globals used to produce the pointer to the MSG structure
  ' are to reduce the redundant load / store operations with the
  ' following 3 API functions in the DO / LOOP message loop.
  ' ----------------------------------------------------------------

    GLOBAL pmsg as DWORD                            ' structure pointer
    GLOBAL MSG as tagMSG                            ' MSG structure

    MessageBox hWnd,"Entering the main message loop next", _
                    "Reference Window",%MB_OK

    pmsg = VarPtr(MSG)

    do while GetMessage(ByVal pmsg,%NULL,0,0) <> 0  ' get the next message in this thread's message que
      TranslateMessage ByVal pmsg                   ' translate any virtual-key messages
      DispatchMessage  ByVal pmsg                   ' dispatch message to the nominated WndProc address
    loop

    FUNCTION = Msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as LONG, _
                 ByVal Msg    as LONG, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as LONG

    Select Case as LONG Msg                         ' force integer testing of messages

      Case %WM_COMMAND
        Select Case as LONG wParam
          ' process WM_COMMAND messages here
        End Select

      Case %WM_CREATE
        MessageBox hWin,"The CreateWindowEx() function has not returned yet", _
                        "WM_CREATE in WndProc function here",%MB_OK

      Case %WM_SIZE
        ' client area resizing code here

      Case %WM_CLOSE
        MessageBox hWin,"Application is being closed","WM_CLOSE message here",%MB_OK

      Case %WM_DESTROY
        PostQuitMessage 0                           ' terminate the message loop

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

