' 

    #INCLUDE "childwin.inc"

    DECLARE FUNCTION childwin(ByVal hParent as DWORD, _
                              ByVal tx as LONG,ByVal ty as LONG, _
                              ByVal wd as LONG,ByVal ht as LONG) as DWORD


' 

FUNCTION PBmain() AS LONG

    LOCAL  Wid            as LONG
    LOCAL  Hgt            as LONG
    LOCAL  wcex           as WNDCLASSEX
    LOCAL  szClassName    as ASCIIZ * 32
    LOCAL  szDisplayName  as ASCIIZ * 128

    hInstance     = GetModuleHandle(ByVal %NULL)
    szDisplayName = "Parent for child window"
    szClassName   = "Base_Win_Class"

    Sw = GetSystemMetrics(%SM_CXSCREEN)     ' get the screen X and Y size
    Sh = GetSystemMetrics(%SM_CYSCREEN)

    hIcon   = LoadIcon(hInstance,ByVal 1)   ' get system icon and cursor handles
    hCursor = LoadCursor(%NULL,ByVal %IDC_ARROW)

  ' ---------------------------------------------------------------------
  ' preload the WNDCLASSEX structure with arguments for RegisterClassEx()
  ' ---------------------------------------------------------------------

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = hCursor
    wcex.hbrBackground = %COLOR_BTNFACE + 1
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex                ' register the window class

    Wid = Sw * .75   ' Set width & height to percentage of screen size.
    Hgt = Sh * .70

    hWnd = CreateWindowEx( _
                        %WS_EX_LEFT, _           ' extended style
                        szClassName, _           ' window class name
                        szDisplayName, _         ' window title
                        %WS_OVERLAPPEDWINDOW, _  ' window style
                        Sw\2-(Wid\2), _          ' initial x position
                        Sh\2-(Hgt\2), _          ' initial y position
                        Wid, _                   ' initial x size
                        Hgt, _                   ' initial y size
                        %NULL, _                 ' parent window handle
                        %NULL, _                 ' window menu handle
                        hInstance, _             ' program instance handle
                        ByVal %NULL)             ' creation parameters


    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop              ' call the remote message loop function

END FUNCTION

' 

FUNCTION MessageLoop as DWORD

  ' -------------------------------------
  ' this is a manually coded message loop
  ' using some assembler instructions to
  ' produce more efficient loop code
  ' -------------------------------------

    GLOBAL pmsg as DWORD                ' structure pointer
    GLOBAL MSG as tagMSG                ' MSG structure

    pmsg = VarPtr(MSG)

    ! jmp InLoop

  MsgLoop:
    TranslateMessage ByVal pmsg         ' translate any virtual-key messages
    DispatchMessage  ByVal pmsg         ' dispatch message to the nominated WndProc address
  InLoop:
    GetMessage(ByVal pmsg,%NULL,0,0)
    ! test eax, eax                     ' test if GetMessage has returned ZERO
    ! jnz MsgLoop                       ' loop again if not

    FUNCTION = Msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as LONG, _
                 ByVal Msg    as LONG, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as LONG

    LOCAL pthbuffer as ASCIIZ * %MAX_PATH

    Select Case as LONG Msg             ' force integer testing of messages

      Case %WM_COMMAND
        Select Case as LONG wParam
          Case 1000
            hChild = childwin(hWin,100,100,400,300)


          Case 1001

          Case 1098
          ' ----------------------
          ' clean application exit
          ' ----------------------
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,0

          Case 1099
            ShellAbout hWin,"  About Template#Windows PBwin 8.4 Template",_
                       "Template Copyright  2007"+chr$(13,10)+_
                       "hutch@movsd.com", hIcon
        End Select

      Case %WM_CREATE


      Case %WM_SIZE
        ' client area resizing code here

      Case %WM_CLOSE
        ' code for cleanup here

      Case %WM_DESTROY
        PostQuitMessage 0               ' terminate the message loop

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION childwin(ByVal hParent as DWORD, _
                  ByVal tx as LONG,ByVal ty as LONG, _
                  ByVal wd as LONG,ByVal ht as LONG) as DWORD

    LOCAL hndl as DWORD
    LOCAL  wcex as WNDCLASSEX
    LOCAL  szClassName as ASCIIZ * 32
    LOCAL  szDisplayName  as ASCIIZ * 128

    szClassName   = "Child_Win_Class"
    szDisplayName = "Child Window"

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(childwinproc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = hCursor
    wcex.hbrBackground = %COLOR_BTNFACE + 1
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex                ' register the window class

    hndl = CreateWindowEx( _
                        %WS_EX_LEFT, _           ' extended style
                        szClassName, _           ' window class name
                        szDisplayName, _         ' window title
                        %WS_OVERLAPPEDWINDOW, _  ' window style
                        tx, _                    ' initial x position
                        ty, _                    ' initial y position
                        wd, _                    ' initial width
                        ht, _                    ' initial height
                        hParent, _               ' parent window handle
                        %NULL, _                 ' window menu handle
                        hInstance, _             ' program instance handle
                        ByVal %NULL)             ' creation parameters

    ShowWindow hndl,%SW_SHOW

    FUNCTION = hndl

END FUNCTION

' 

FUNCTION childwinproc(ByVal hWin   as LONG, _
                      ByVal Msg    as LONG, _
                      ByVal wParam as LONG, _
                      ByVal lParam as LONG) as LONG

  ' in this example no messages are processed.

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 
